
function Perl_ColorChange_OnLoad()
	this:RegisterEvent("PLAYER_TARGET_CHANGED");
	this:RegisterEvent("UNIT_AURA");
	this:RegisterEvent("UNIT_FACTION");
	DEFAULT_CHAT_FRAME:AddMessage("Perl_ColorChange loaded.");
end

function Perl_ColorChange_OnEvent (event)
	if event == "PLAYER_TARGET_CHANGED" or event == "UNIT_FACTION" then
     colorTarget () ;
  end
  if ( event =="UNIT_AURA" ) then
  
  --		DEFAULT_CHAT_FRAME:AddMessage("UNIT_AURA>>"..arg1);
  	local debuffType = getDebuffType (arg1) ;
  	colorDebufFrame (arg1, debuffType) ;
  	return ;
  end
  	
end

function colorDebufFrame (display, type)
	local r ;
	local v ;
	local b ;
	local rB ;
	local vB ;
	local bB ;
	local a = 1 ;
	
	if not display then
		return ;
	end

  	if display == "party1" then
  		frame = "Perl_Party_MemberFrame1_PortraitFrame" ;
  	elseif display == "party2" then
  		frame = "Perl_Party_MemberFrame2_PortraitFrame" ;
  	elseif display == "party3" then
  		frame = "Perl_Party_MemberFrame3_PortraitFrame" ;
  	elseif display == "party4" then
  		frame = "Perl_Party_MemberFrame4_PortraitFrame" ;
  	elseif display == "partypet1" then
  		frame = "Perl_Party_Pet1_PortraitFrame" ;
  	elseif display == "partypet2" then
  		frame = "Perl_Party_Pet2_PortraitFrame" ;
  	elseif display == "partypet3" then
  		frame = "Perl_Party_Pet3_PortraitFrame" ;
  	elseif display == "partypet4" then
  		frame = "Perl_Party_Pet4_PortraitFrame" ;
  	elseif display == "pet" then
  		frame = "Perl_Player_Pet_PortraitFrame" ;
  	elseif display == "player" then
  		frame = "Perl_Player_PortraitFrame" ; 
  	else
  		return ;		
  	end
	
 --DEFAULT_CHAT_FRAME:AddMessage("FRAME>>"..frame);
	if type == "none" then
	 	r = 0 ;
	 	v = 0 ;
	 	b = 0 ;
	 	rB = 0.5 ;
	 	vB = 0.5 ;
	 	bB = 0.5 ;
	elseif type == "Magic" then
			r = 0.15 ;
			v = 0.15 ;
			b = 0.9 ;
			rB = 0.50 ;
      vB = 0.50;
      bB = 1 ;
	elseif type == "Curse" then
			r = 0.74 ;
			v = 0.15 ;
			b = 0.78 ;
			rB = 0.95 ;
      vB = 0;
      bB = 0.75 ;
	elseif type == "Poison" then
			r = 0 ;
			v = 0.75 ;
			b = 0 ;
			rB = 0 ;
      vB = 0.70;
      bB = 0 ;
	elseif type == "Disease" then
			r = 1 ;
			v = 0 ;
			b = 0 ;
			rB = 1 ;
      vB = 0 ;
      bB = 0 ;
	end
		getglobal(frame):SetBackdrop(
				{
					bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
	        edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
	        tile = true, tileSize = 32, edgeSize = 20, 
	        insets = { 
	        	left = 5, 
	        	right = 5, 
	        	top = 5, 
	        	bottom = 5 
	        }
	       }
	       );
		getglobal(frame):SetBackdropColor(r, v, b, a);
		getglobal(frame):SetBackdropBorderColor(rB, vB, bB, a);

end

function getDebuffType (t)
	local type ;
	for i=1, MAX_PARTY_TOOLTIP_DEBUFFS do
	      _, _, tempType = UnitDebuff(t, i) ;
	      if tempType then
	        type = tempType ;
	      end 
	end
	if not type then
		type = "none" ;
	end
	--DEFAULT_CHAT_FRAME:AddMessage("debuff: "..type);
	return type ;
end

function colorTarget ()
	local r = 0.5;
	local v = 0.5;
	local b = 0.5;
	local a = 1;
	local p = "player" ;
	local t = "target" ;
	local status = UnitReaction(p,t) ;
	if UnitExists(t) and status then
		if status <= 3 then
		  r=1;
		  v=0;
		  b=0;
		end
		if status == 4 then
		  r=1;
		  v=1;
		  b=0;
		end
		if status >= 5 then
		  r=0;
		  v=0.75;
		  b=0;
		end
		--Perl_Target_StatsFrame:SetBackdropBorderColor(r, v, b, a);
		--Perl_Target_ClassNameFrame:SetBackdropBorderColor(r, v, b, a);
		--Perl_Target_LevelFrame:SetBackdropBorderColor(r, v, b, a);
		--Perl_Target_PortraitFrame:SetBackdropBorderColor(r, v, b, a);
		--Perl_Target_NameFrame:SetBackdropBorderColor(r, v, b, a);
		Perl_Target_PortraitFrame:SetBackdrop(
			{
				bgFile = "Interface/Tooltips/UI-Tooltip-Background", 
        edgeFile = "Interface/Tooltips/UI-Tooltip-Border", 
        tile = true, tileSize = 32, edgeSize = 20, 
        insets = { 
        	left = 5, 
        	right = 5, 
        	top = 5, 
        	bottom = 5 
        }
       }
       );
		Perl_Target_PortraitFrame:SetBackdropColor(r, v, b, a);
		Perl_Target_PortraitFrame:SetBackdropBorderColor(r, v, b, a);
		Perl_Target_PortraitFrame:SetBackdropBorderColor(r, v, b, a);
	end
end
